﻿// CreateSolidDlg.cpp
//

#include "stdafx.h"
#include "CreateSolidDlg.h"
#include "afxdialogex.h"


IMPLEMENT_DYNAMIC(CreateSolidDlg, CDialogEx)

CreateSolidDlg::CreateSolidDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_CREATE_SOLID_DIALOG, pParent)
	, m_iShape(0)
	, m_dEditS1(m_dBlock_X)
	, m_dEditS2(m_dBlock_Y)
	, m_dEditS3(m_dBlock_Z)
	, m_dEditOX(0)
	, m_dEditOY(0)
	, m_dEditOZ(0)
	, m_dEditDX(0)
	, m_dEditDY(0)
	, m_dEditDZ(1)
{
}

CreateSolidDlg::~CreateSolidDlg()
{
}

void CreateSolidDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_XL, m_dEditS1);
	DDX_Text(pDX, IDC_EDIT_YL, m_dEditS2);
	DDX_Text(pDX, IDC_EDIT_ZL, m_dEditS3);
	DDX_Text(pDX, IDC_EDIT_OX, m_dEditOX);
	DDX_Text(pDX, IDC_EDIT_OY, m_dEditOY);
	DDX_Text(pDX, IDC_EDIT_OZ, m_dEditOZ);
	DDX_Text(pDX, IDC_EDIT_DX, m_dEditDX);
	DDX_Text(pDX, IDC_EDIT_DY, m_dEditDY);
	DDX_Text(pDX, IDC_EDIT_DZ, m_dEditDZ);
	DDX_Radio(pDX, IDC_RADIO_BLOCK, m_iShape);
}

BOOL CreateSolidDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	UpdateData(false);

	return 0;
}


BEGIN_MESSAGE_MAP(CreateSolidDlg, CDialogEx)
	ON_BN_CLICKED(IDC_RADIO_BLOCK, &CreateSolidDlg::OnBnClickedRadioBlock)
	ON_BN_CLICKED(IDC_RADIO_CYLINDER, &CreateSolidDlg::OnBnClickedRadioCylinder)
END_MESSAGE_MAP()


void CreateSolidDlg::updateUI()
{
	UpdateData(true);

	((CStatic*)GetDlgItem(IDC_STATIC_ZL))->ShowWindow(true);
	((CEdit*)GetDlgItem(IDC_EDIT_ZL))->ShowWindow(true);

	switch (m_iShape)
	{
	case 0:
		SetWindowText(_T("Create Block"));
		((CStatic*)GetDlgItem(IDC_STATIC_XL))->SetWindowTextW(_T("X"));
		((CStatic*)GetDlgItem(IDC_STATIC_YL))->SetWindowTextW(_T("Y")); 
		break;
	case 1:
		SetWindowText(_T("Create Cylinder"));
		((CStatic*)GetDlgItem(IDC_STATIC_XL))->SetWindowTextW(_T("R"));
		((CStatic*)GetDlgItem(IDC_STATIC_YL))->SetWindowTextW(_T("H"));
		((CStatic*)GetDlgItem(IDC_STATIC_ZL))->ShowWindow(false);
		((CEdit*)GetDlgItem(IDC_EDIT_ZL))->ShowWindow(false);

		m_dEditS1 = m_dCyl_R;
		m_dEditS2 = m_dCyl_H;
		break;
	default:
		break;
	}

	UpdateData(false);
}


void CreateSolidDlg::OnBnClickedRadioBlock()
{
	updateUI();
}


void CreateSolidDlg::OnBnClickedRadioCylinder()
{
	updateUI();
}
